﻿using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Net;
using System.Windows.Media.Imaging;

namespace LoadingImages_Tutorial
{
	public partial class Page : UserControl
	{
        public Page()
        {
            // Required to initialize variables
            InitializeComponent();

            // Load the image once the page has loaded
            LoadImage();
        }

        private void LoadImage()
        {
            // 
            // Creating WebClient object and setting up events 
            // 
            WebClient downloader = new WebClient();
            downloader.OpenReadCompleted += new OpenReadCompletedEventHandler(downloader_OpenReadCompleted);
            downloader.DownloadProgressChanged += new DownloadProgressChangedEventHandler(downloader_DownloadProgressChanged);

            // 
            // Specify Image to load 
            //
            int randomSeed = new Random().Next(10000);
            string fileName = "kirupaCard.jpg?=" + randomSeed.ToString();

            downloader.OpenReadAsync(new Uri(fileName, UriKind.Relative));
        }

        void downloader_OpenReadCompleted(object sender, OpenReadCompletedEventArgs e)
        {
            // 
            // Create a new BitmapImage and load the stream 
            // 
            BitmapImage loadedImage = new BitmapImage();
            loadedImage.SetSource(e.Result);

            // 
            // Setting our BitmapImage as the source of a imageControl control I have specified XAML 
            // 
            imageControl.Source = loadedImage;
        }

        void downloader_DownloadProgressChanged(object sender, DownloadProgressChangedEventArgs e)
        {
            // Progress Updates 
            progressBar.Value = e.ProgressPercentage;
        }

        private void ReloadImage(object sender, RoutedEventArgs e)
        {
            imageControl.Source = null;
            LoadImage();
        }
	}
}